Summary:       An eBPF-based tool to trace network packet and diagnose network problem
Name:          nettrace
Version:       1.2.9
Release:       1%{?dist}
License:       MulanPSL-2.0
Source0:       https://github.com/OpenCloudOS/nettrace/archive/refs/tags/v%{version}.tar.gz #/%{name}-%{version}.tar.gz

BuildRequires: elfutils-devel elfutils-devel-static libbpf-devel libbpf-static python3 python3-pyyaml
BuildRequires: kernel-headers kernel-devel clang llvm gcc bpftool
BuildRequires: glibc-static glibc-devel zlib-static zlib-devel python3 python3-pyyaml


%description
nettrace is is a powerful tool to trace network packet and diagnose
network problem inside kernel. It make use of eBPF.

'skb' is the struct that used in kernel to store network package.
By tracing kernel function and tracepoint (with the help of kprobe
based on eBPF) that handle skb, nettrace is able to show the path
of skb bypass inside kernel network stack. Therefor, some network
issue (such as package drop) can be solved simply.


%prep
%setup -q


%install
rm -rf $RPM_BUILD_ROOT
make PREFIX=$RPM_BUILD_ROOT install


%files
%defattr (-,root,root,0755)
/opt/nettrace/
/usr/bin/nettrace
/usr/bin/nettrace-legacy
/usr/bin/nodetrace-mark
/usr/bin/nodetrace-watch
/usr/share/man/man8/nettrace-legacy.8.gz
/usr/share/man/zh_CN/man8/nettrace.8.gz
/usr/share/man/man8/nettrace.8.gz
/usr/share/man/man8/dropreason.8.gz
/usr/share/bash-completion/completions/nettrace


%changelog
* Thu Apr 18 2024 rockerzhu <rockerzhu@tencent.com> - 1.2.9-1
- Upgrade to 1.2.9
- Improve the SPEC file to adapt the new os release.

* Tue Jan 10 2023 Xun Zhong <victorzhong@tencent.com> - 1.2.3-1
- init
